Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/SelfTest/src/test.cpp	(revision 112)
@@ -104,12 +104,12 @@
   ALLOC1_SC_SIGNAL( in_CONTEXT_DEPTH_VAL                  ," in_CONTEXT_DEPTH_VAL                  ",Tcontrol_t         ,_param->_nb_context);
   ALLOC1_SC_SIGNAL( in_CONTEXT_DEPTH                      ," in_CONTEXT_DEPTH                      ",Tdepth_t           ,_param->_nb_context);
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_VAL                  ,"out_CONTEXT_EVENT_VAL                  ",Tcontrol_t         );
-  ALLOC_SC_SIGNAL ( in_CONTEXT_EVENT_ACK                  ," in_CONTEXT_EVENT_ACK                  ",Tcontrol_t         );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_CONTEXT_ID           ,"out_CONTEXT_EVENT_CONTEXT_ID           ",Tcontext_t         );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_DEPTH                ,"out_CONTEXT_EVENT_DEPTH                ",Tdepth_t           );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_TYPE                 ,"out_CONTEXT_EVENT_TYPE                 ",Tevent_type_t      );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_IS_DELAY_SLOT        ,"out_CONTEXT_EVENT_IS_DELAY_SLOT        ",Tcontrol_t         );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_ADDRESS              ,"out_CONTEXT_EVENT_ADDRESS              ",Tgeneral_data_t    );
-  ALLOC_SC_SIGNAL (out_CONTEXT_EVENT_ADDRESS_EPCR         ,"out_CONTEXT_EVENT_ADDRESS_EPCR         ",Tgeneral_data_t    );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_VAL                  ,"out_CONTEXT_EVENT_VAL                  ",Tcontrol_t         );
+  ALLOC0_SC_SIGNAL( in_CONTEXT_EVENT_ACK                  ," in_CONTEXT_EVENT_ACK                  ",Tcontrol_t         );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_CONTEXT_ID           ,"out_CONTEXT_EVENT_CONTEXT_ID           ",Tcontext_t         );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_DEPTH                ,"out_CONTEXT_EVENT_DEPTH                ",Tdepth_t           );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_TYPE                 ,"out_CONTEXT_EVENT_TYPE                 ",Tevent_type_t      );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_IS_DELAY_SLOT        ,"out_CONTEXT_EVENT_IS_DELAY_SLOT        ",Tcontrol_t         );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_ADDRESS              ,"out_CONTEXT_EVENT_ADDRESS              ",Tgeneral_data_t    );
+  ALLOC0_SC_SIGNAL(out_CONTEXT_EVENT_ADDRESS_EPCR         ,"out_CONTEXT_EVENT_ADDRESS_EPCR         ",Tgeneral_data_t    );
   
   /********************************************************
@@ -135,8 +135,8 @@
     {
       if (_param->_have_port_inst_ifetch_ptr)
-        INSTANCE_SC_SIGNAL(_Decod, in_IFETCH_INST_IFETCH_PTR [i]);
+        INSTANCE0_SC_SIGNAL(_Decod, in_IFETCH_INST_IFETCH_PTR [i]);
 //       if (_param->_have_port_branch_update_prediction_id)
       if (_param->_have_port_depth)
-        INSTANCE_SC_SIGNAL(_Decod, in_IFETCH_BRANCH_UPDATE_PREDICTION_ID [i]);
+        INSTANCE0_SC_SIGNAL(_Decod, in_IFETCH_BRANCH_UPDATE_PREDICTION_ID [i]);
     }
 
@@ -188,15 +188,15 @@
   for (uint32_t i=0; i<_param->_nb_context; i++)
     if (_param->_have_port_depth)
-      INSTANCE_SC_SIGNAL(_Decod, in_CONTEXT_DEPTH [i]);
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_VAL                  );
-  INSTANCE_SC_SIGNAL (_Decod, in_CONTEXT_EVENT_ACK                  );
+      INSTANCE0_SC_SIGNAL(_Decod, in_CONTEXT_DEPTH [i]);
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_VAL                  );
+  INSTANCE0_SC_SIGNAL(_Decod, in_CONTEXT_EVENT_ACK                  );
   if (_param->_have_port_context_id)
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_CONTEXT_ID           );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_CONTEXT_ID           );
   if (_param->_have_port_depth)
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_DEPTH                );
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_TYPE                 );
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_IS_DELAY_SLOT        );
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_ADDRESS              );
-  INSTANCE_SC_SIGNAL (_Decod,out_CONTEXT_EVENT_ADDRESS_EPCR         );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_DEPTH                );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_TYPE                 );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_IS_DELAY_SLOT        );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_ADDRESS              );
+  INSTANCE0_SC_SIGNAL(_Decod,out_CONTEXT_EVENT_ADDRESS_EPCR         );
 
   msg(_("<%s> : Start Simulation ............\n"),name.c_str());
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Parameters.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/include/Parameters.h	(revision 112)
@@ -23,4 +23,20 @@
 namespace decod {
 
+    const uint32_t nb_opcod_type = 14;
+    const uint32_t tab_opcod_type [] = {MAX_OPCOD_0,
+                                        MAX_OPCOD_1 ,
+                                        MAX_OPCOD_2 ,
+                                        MAX_OPCOD_3 ,
+                                        MAX_OPCOD_4 ,
+                                        MAX_OPCOD_5 ,
+                                        MAX_OPCOD_6 ,
+                                        MAX_OPCOD_7 ,
+                                        MAX_OPCOD_8 ,
+                                        MAX_OPCOD_9 ,
+                                        MAX_OPCOD_10,
+                                        MAX_OPCOD_11,
+                                        MAX_OPCOD_12,
+                                        MAX_OPCOD_13};
+
   class Parameters : public morpheo::behavioural::Parameters
   {
@@ -37,5 +53,5 @@
   public : bool             ** _instruction_implemeted       ; //[nb_context][nb_instruction]
   public : morpheo::behavioural::custom::custom_information_t (*_get_custom_information) (void);
-    
+
   public : uint32_t            _max_nb_inst_fetch;
 //public : uint32_t            _size_address_inst;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_allocation.cpp	(revision 112)
@@ -58,5 +58,5 @@
     // ~~~~~[ Interface : "ifetch" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC2_INTERFACE("ifetch", IN, WEST, "Instruction's bundle", _param->_nb_context, _param->_nb_inst_fetch[it1]);
+      ALLOC2_INTERFACE_BEGIN("ifetch", IN, WEST, _("Instruction's bundle"), _param->_nb_context, _param->_nb_inst_fetch[it1]);
 
       
@@ -64,8 +64,11 @@
       _ALLOC2_VALACK_OUT(out_IFETCH_ACK        ,ACK, _param->_nb_context, _param->_nb_inst_fetch[it1]);
       _ALLOC2_SIGNAL_IN ( in_IFETCH_INSTRUCTION,"instruction", Tinstruction_t, _param->_size_instruction,_param->_nb_context, _param->_nb_inst_fetch[it1]);
-    }
-    {
-      ALLOC1_INTERFACE("ifetch", IN, WEST, "Instruction's bundle", _param->_nb_context);
+
+      ALLOC2_INTERFACE_END(_param->_nb_context, _param->_nb_inst_fetch[it1]);
+    }
+    {
+      ALLOC1_INTERFACE_BEGIN("ifetch", IN, WEST, _("Instruction's bundle"), _param->_nb_context);
       
+
       ALLOC1_SIGNAL_IN (in_IFETCH_CONTEXT_ID                 ,"context_id"                 ,Tcontext_t         ,_param->_size_context_id      );
       ALLOC1_SIGNAL_IN (in_IFETCH_ADDRESS                    ,"address"                    ,Tgeneral_address_t ,_param->_size_instruction_address    );
@@ -75,9 +78,11 @@
       ALLOC1_SIGNAL_IN (in_IFETCH_BRANCH_UPDATE_PREDICTION_ID,"branch_update_prediction_id",Tprediction_ptr_t  ,_param->_size_depth           );
       ALLOC1_SIGNAL_IN (in_IFETCH_EXCEPTION                  ,"exception"                  ,Texception_t       ,_param->_size_exception_ifetch);
+
+      ALLOC1_INTERFACE_END(_param->_nb_context);
     }
 
     // ~~~~~[ Interface : "decod" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~           
     {
-      ALLOC1_INTERFACE("decod", OUT, EAST, "Instructiont decoded", _param->_nb_inst_decod);
+      ALLOC1_INTERFACE_BEGIN("decod", OUT, EAST, _("Instructiont decoded"), _param->_nb_inst_decod);
 
       ALLOC1_VALACK_OUT(out_DECOD_VAL          ,VAL);
@@ -107,9 +112,11 @@
       ALLOC1_SIGNAL_OUT(out_DECOD_EXCEPTION_USE,"exception_use",Texception_t      ,_param->_size_exception_use         );
       ALLOC1_SIGNAL_OUT(out_DECOD_EXCEPTION    ,"exception"    ,Texception_t      ,_param->_size_exception_decod       );
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_decod);
     }
 
     // ~~~~~[ Interface : "predict" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("predict",OUT,NORTH,"Decod a branch -> inform the branch predictor.",_param->_nb_inst_decod);
+      ALLOC1_INTERFACE_BEGIN("predict",OUT,NORTH,_("Decod a branch -> inform the branch predictor."),_param->_nb_inst_decod);
 
       ALLOC1_VALACK_OUT(out_PREDICT_VAL                        ,VAL);
@@ -125,27 +132,33 @@
       ALLOC1_SIGNAL_OUT(out_PREDICT_ADDRESS_DEST               ,"address_dest"               ,Tgeneral_data_t    ,_param->_size_instruction_address    );
       ALLOC1_SIGNAL_IN ( in_PREDICT_CAN_CONTINUE               ,"can_continue"               ,Tcontrol_t         ,1                             );
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_decod);
     }
     
     // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("context", IN, NORTH, "context's information", _param->_nb_context);
+      ALLOC1_INTERFACE_BEGIN("context", IN, NORTH, _("context's information"), _param->_nb_context);
 
       ALLOC1_SIGNAL_IN (in_CONTEXT_DECOD_ENABLE,"decod_enable",Tcontrol_t,1);
       ALLOC1_SIGNAL_IN (in_CONTEXT_DEPTH_VAL   ,"depth_val"   ,Tcontrol_t,1);
       ALLOC1_SIGNAL_IN (in_CONTEXT_DEPTH       ,"depth"       ,Tdepth_t  ,_param->_size_depth);
+
+      ALLOC1_INTERFACE_END(_param->_nb_context);
     }
 
     // ~~~~~[ Interface : "context_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~           
     {
-      ALLOC_INTERFACE("context_event", OUT, NORTH, "context's evenement");
-
-      ALLOC_VALACK_OUT(out_CONTEXT_EVENT_VAL          ,VAL);
-      ALLOC_VALACK_IN ( in_CONTEXT_EVENT_ACK          ,ACK);
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_CONTEXT_ID   ,"context_id"   ,Tcontext_t     ,_param->_size_context_id  );
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_DEPTH        ,"depth"        ,Tdepth_t       ,_param->_size_depth       );
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_TYPE         ,"type"         ,Tevent_type_t  ,_param->_size_event_type  );
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_IS_DELAY_SLOT,"is_delay_slot",Tcontrol_t     ,1                         );
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_ADDRESS      ,"address"      ,Tgeneral_data_t,_param->_size_instruction_address);
-      ALLOC_SIGNAL_OUT(out_CONTEXT_EVENT_ADDRESS_EPCR ,"address_epcr" ,Tgeneral_data_t,_param->_size_instruction_address);
+      ALLOC0_INTERFACE_BEGIN("context_event", OUT, NORTH, _("context's evenement"));
+
+      ALLOC0_VALACK_OUT(out_CONTEXT_EVENT_VAL          ,VAL);
+      ALLOC0_VALACK_IN ( in_CONTEXT_EVENT_ACK          ,ACK);
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_CONTEXT_ID   ,"context_id"   ,Tcontext_t     ,_param->_size_context_id  );
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_DEPTH        ,"depth"        ,Tdepth_t       ,_param->_size_depth       );
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_TYPE         ,"type"         ,Tevent_type_t  ,_param->_size_event_type  );
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_IS_DELAY_SLOT,"is_delay_slot",Tcontrol_t     ,1                         );
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_ADDRESS      ,"address"      ,Tgeneral_data_t,_param->_size_instruction_address);
+      ALLOC0_SIGNAL_OUT(out_CONTEXT_EVENT_ADDRESS_EPCR ,"address_epcr" ,Tgeneral_data_t,_param->_size_instruction_address);
+
+      ALLOC0_INTERFACE_END();
     }
 
@@ -154,13 +167,13 @@
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
-    reg_CONTEXT_ADDRESS_PREVIOUS      = new Tgeneral_data_t [_param->_nb_context];
-    reg_CONTEXT_IS_DELAY_SLOT         = new Tcontrol_t      [_param->_nb_context];
-
-    internal_CONTEXT_HAVE_TRANSACTION = new Tcontrol_t      [_param->_nb_context];
-    internal_CONTEXT_ADDRESS_PREVIOUS = new Tgeneral_data_t [_param->_nb_context];
-    internal_CONTEXT_IS_DELAY_SLOT    = new Tcontrol_t      [_param->_nb_context];
+    ALLOC1(reg_CONTEXT_ADDRESS_PREVIOUS      ,Tgeneral_data_t,_param->_nb_context);
+    ALLOC1(reg_CONTEXT_IS_DELAY_SLOT         ,Tcontrol_t     ,_param->_nb_context);
+
+    ALLOC1(internal_CONTEXT_HAVE_TRANSACTION ,Tcontrol_t     ,_param->_nb_context);
+    ALLOC1(internal_CONTEXT_ADDRESS_PREVIOUS ,Tgeneral_data_t,_param->_nb_context);
+    ALLOC1(internal_CONTEXT_IS_DELAY_SLOT    ,Tcontrol_t     ,_param->_nb_context);
 
 #ifdef STATISTICS
-    internal_DECOD_VAL                = new Tcontrol_t      [_param->_nb_inst_decod];
+    ALLOC1(internal_DECOD_VAL                ,Tcontrol_t     ,_param->_nb_inst_decod);
 #endif
       }
@@ -174,36 +187,15 @@
                                                  _param->_nb_context_select);
 
-    const uint32_t nb_opcod_type = 14;
-    const uint32_t tab_opcod_type [] = {MAX_OPCOD_0,
-                                        MAX_OPCOD_1 ,
-                                        MAX_OPCOD_2 ,
-                                        MAX_OPCOD_3 ,
-                                        MAX_OPCOD_4 ,
-                                        MAX_OPCOD_5 ,
-                                        MAX_OPCOD_6 ,
-                                        MAX_OPCOD_7 ,
-                                        MAX_OPCOD_8 ,
-                                        MAX_OPCOD_9 ,
-                                        MAX_OPCOD_10,
-                                        MAX_OPCOD_11,
-                                        MAX_OPCOD_12,
-                                        MAX_OPCOD_13};
-    
-    _function_decod  = new function_decod_t *** [_param->_nb_context];
-    _function_custom = new function_decod_t *** [_param->_nb_context];
+    ALLOC3(_function_decod ,function_decod_t *,_param->_nb_context,nb_opcod_type,tab_opcod_type[it2]);
+    ALLOC3(_function_custom,function_decod_t *,_param->_nb_context,nb_opcod_type,tab_opcod_type[it2]);
+
     for (uint32_t i=0; i<_param->_nb_context; i++)
       {
-        _function_decod  [i] = new function_decod_t ** [nb_opcod_type];
-        _function_custom [i] = new function_decod_t ** [nb_opcod_type];
         for (uint32_t j=0; j<nb_opcod_type; j++)
-          {
-            _function_decod  [i][j] = new function_decod_t * [tab_opcod_type[j]];
-            _function_custom [i][j] = new function_decod_t * [tab_opcod_type[j]];
-            for (uint32_t k=0; k<tab_opcod_type[j]; k++)
-              {
-                _function_decod  [i][j][k] = &(instruction_illegal);
-                _function_custom [i][j][k] = &(instruction_illegal);
-              }
-          }
+          for (uint32_t k=0; k<tab_opcod_type[j]; k++)
+            {
+              _function_decod  [i][j][k] = &(instruction_illegal);
+              _function_custom [i][j][k] = &(instruction_illegal);
+            }
 
         // Create indirection
@@ -454,7 +446,7 @@
       }
 
-    _decod_instruction = new decod_instruction_t;
-
-    _decod_param = new decod_param_t * [_param->_nb_context];
+    ALLOC0(_decod_instruction,decod_instruction_t);
+    ALLOC1(_decod_param,decod_param_t *,_param->_nb_context);
+
     for (uint32_t i=0; i<_param->_nb_context; i++)
       _decod_param [i] = new decod_param_t (_param->_size_general_data,
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_deallocation.cpp	(revision 112)
@@ -85,24 +85,22 @@
         DELETE1_SIGNAL(in_CONTEXT_DEPTH       , _param->_nb_context,_param->_size_depth);
 
-        DELETE_SIGNAL (out_CONTEXT_EVENT_VAL          ,1);
-        DELETE_SIGNAL ( in_CONTEXT_EVENT_ACK          ,1);
-        DELETE_SIGNAL (out_CONTEXT_EVENT_CONTEXT_ID   ,_param->_size_context_id  );
-        DELETE_SIGNAL (out_CONTEXT_EVENT_DEPTH        ,_param->_size_depth       );
-        DELETE_SIGNAL (out_CONTEXT_EVENT_TYPE         ,_param->_size_event_type  );
-        DELETE_SIGNAL (out_CONTEXT_EVENT_IS_DELAY_SLOT,1                         );
-        DELETE_SIGNAL (out_CONTEXT_EVENT_ADDRESS      ,_param->_size_instruction_address);
-        DELETE_SIGNAL (out_CONTEXT_EVENT_ADDRESS_EPCR ,_param->_size_instruction_address);
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_VAL          ,1);
+        DELETE0_SIGNAL( in_CONTEXT_EVENT_ACK          ,1);
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_CONTEXT_ID   ,_param->_size_context_id  );
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_DEPTH        ,_param->_size_depth       );
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_TYPE         ,_param->_size_event_type  );
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_IS_DELAY_SLOT,1                         );
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_ADDRESS      ,_param->_size_instruction_address);
+        DELETE0_SIGNAL(out_CONTEXT_EVENT_ADDRESS_EPCR ,_param->_size_instruction_address);
 
 
-    
-        delete    reg_CONTEXT_ADDRESS_PREVIOUS      ;
-        delete [] reg_CONTEXT_IS_DELAY_SLOT         ;
-        
-        delete [] internal_CONTEXT_HAVE_TRANSACTION ;
-        delete [] internal_CONTEXT_ADDRESS_PREVIOUS ;
-        delete [] internal_CONTEXT_IS_DELAY_SLOT    ;
-        
+        DELETE1(reg_CONTEXT_ADDRESS_PREVIOUS      ,_param->_nb_context);
+        DELETE1(reg_CONTEXT_IS_DELAY_SLOT         ,_param->_nb_context);
+        DELETE1(internal_CONTEXT_HAVE_TRANSACTION ,_param->_nb_context);
+        DELETE1(internal_CONTEXT_ADDRESS_PREVIOUS ,_param->_nb_context);
+        DELETE1(internal_CONTEXT_IS_DELAY_SLOT    ,_param->_nb_context);
+
 #ifdef STATISTICS
-        delete [] internal_DECOD_VAL;
+        DELETE1(internal_DECOD_VAL                ,_param->_nb_inst_decod);
 #endif
       }
@@ -111,21 +109,12 @@
     delete    _priority;
 
-
-    const uint32_t nb_opcod_type = 14;
+    DELETE3(_function_decod   ,_param->_nb_context,nb_opcod_type,tab_opcod_type[it2]);
+    DELETE3(_function_custom  ,_param->_nb_context,nb_opcod_type,tab_opcod_type[it2]);
+    DELETE0(_decod_instruction);
 
     for (uint32_t i=0; i<_param->_nb_context; i++)
-      {
-	for (uint32_t j=0; j<nb_opcod_type; j++)
-	  {
-	    delete [] _function_decod  [i][j];
-	    delete [] _function_custom [i][j];
-	  }
-	delete [] _function_decod  [i];
-	delete [] _function_custom [i];
-      }
-    delete [] _function_decod ;
-    delete [] _function_custom;
-    delete    _decod_instruction;
-    delete    _decod_param      ;
+      delete _decod_param [i];
+    DELETE1(_decod_param      ,_param->_nb_context);
+
     delete    _component;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Types.h	(revision 112)
@@ -10,4 +10,5 @@
 
 #include "Behavioural/include/Types.h"
+#include "Behavioural/include/Allocation.h"
 
 namespace morpheo {
@@ -58,29 +59,29 @@
     _nb_inst (nb_inst)
     {
-      _val            = new Tcontrol_t         [_nb_inst];
-      _context_id     = new Tcontext_t         [_nb_inst];
-      _depth          = new Tdepth_t           [_nb_inst];
-      _type           = new Ttype_t            [_nb_inst];
-      _operation      = new Toperation_t       [_nb_inst];
-      _no_execute     = new Tcontrol_t         [_nb_inst];
-      _is_delay_slot  = new Tcontrol_t         [_nb_inst];
+      ALLOC1(_val            ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_context_id     ,Tcontext_t         ,_nb_inst);
+      ALLOC1(_depth          ,Tdepth_t           ,_nb_inst);
+      ALLOC1(_type           ,Ttype_t            ,_nb_inst);
+      ALLOC1(_operation      ,Toperation_t       ,_nb_inst);
+      ALLOC1(_no_execute     ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_is_delay_slot  ,Tcontrol_t         ,_nb_inst);
 #ifdef DEBUG
-      _address        = new Tgeneral_data_t    [_nb_inst];
+      ALLOC1(_address        ,Tgeneral_data_t    ,_nb_inst);
 #endif
-      _address_next   = new Tgeneral_data_t    [_nb_inst];
-      _has_immediat   = new Tcontrol_t         [_nb_inst];
-      _immediat       = new Tgeneral_data_t    [_nb_inst];
-      _read_ra        = new Tcontrol_t         [_nb_inst];
-      _num_reg_ra     = new Tgeneral_address_t [_nb_inst];
-      _read_rb        = new Tcontrol_t         [_nb_inst];
-      _num_reg_rb     = new Tgeneral_address_t [_nb_inst];
-      _read_rc        = new Tcontrol_t         [_nb_inst];
-      _num_reg_rc     = new Tspecial_address_t [_nb_inst];
-      _write_rd       = new Tcontrol_t         [_nb_inst];
-      _num_reg_rd     = new Tgeneral_address_t [_nb_inst];
-      _write_re       = new Tcontrol_t         [_nb_inst];
-      _num_reg_re     = new Tspecial_address_t [_nb_inst];
-      _exception_use  = new Texception_t       [_nb_inst];
-      _exception      = new Texception_t       [_nb_inst];
+      ALLOC1(_address_next   ,Tgeneral_data_t    ,_nb_inst);
+      ALLOC1(_has_immediat   ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_immediat       ,Tgeneral_data_t    ,_nb_inst);
+      ALLOC1(_read_ra        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_ra     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_read_rb        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rb     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_read_rc        ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rc     ,Tspecial_address_t ,_nb_inst);
+      ALLOC1(_write_rd       ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_rd     ,Tgeneral_address_t ,_nb_inst);
+      ALLOC1(_write_re       ,Tcontrol_t         ,_nb_inst);
+      ALLOC1(_num_reg_re     ,Tspecial_address_t ,_nb_inst);
+      ALLOC1(_exception_use  ,Texception_t       ,_nb_inst);
+      ALLOC1(_exception      ,Texception_t       ,_nb_inst);
 
       for (uint32_t i=0; i<_nb_inst; i++)
@@ -90,29 +91,29 @@
   public : ~decod_queue_entry_t (void)
     {
-      delete [] _val            ;
-      delete [] _context_id     ;
-      delete [] _depth          ;
-      delete [] _type           ;
-      delete [] _operation      ;
-      delete [] _no_execute     ;
-      delete [] _is_delay_slot  ;
+      DELETE1(_val            ,_nb_inst);
+      DELETE1(_context_id     ,_nb_inst);
+      DELETE1(_depth          ,_nb_inst);
+      DELETE1(_type           ,_nb_inst);
+      DELETE1(_operation      ,_nb_inst);
+      DELETE1(_no_execute     ,_nb_inst);
+      DELETE1(_is_delay_slot  ,_nb_inst);
 #ifdef DEBUG
-      delete [] _address        ;
+      DELETE1(_address        ,_nb_inst);
 #endif
-      delete [] _address_next   ;
-      delete [] _has_immediat   ;
-      delete [] _immediat       ;
-      delete [] _read_ra        ;
-      delete [] _num_reg_ra     ;
-      delete [] _read_rb        ;
-      delete [] _num_reg_rb     ;
-      delete [] _read_rc        ;
-      delete [] _num_reg_rc     ;
-      delete [] _write_rd       ;
-      delete [] _num_reg_rd     ;
-      delete [] _write_re       ;
-      delete [] _num_reg_re     ;
-      delete [] _exception_use  ;
-      delete [] _exception      ;
+      DELETE1(_address_next   ,_nb_inst);
+      DELETE1(_has_immediat   ,_nb_inst);
+      DELETE1(_immediat       ,_nb_inst);
+      DELETE1(_read_ra        ,_nb_inst);
+      DELETE1(_num_reg_ra     ,_nb_inst);
+      DELETE1(_read_rb        ,_nb_inst);
+      DELETE1(_num_reg_rb     ,_nb_inst);
+      DELETE1(_read_rc        ,_nb_inst);
+      DELETE1(_num_reg_rc     ,_nb_inst);
+      DELETE1(_write_rd       ,_nb_inst);
+      DELETE1(_num_reg_rd     ,_nb_inst);
+      DELETE1(_write_re       ,_nb_inst);
+      DELETE1(_num_reg_re     ,_nb_inst);
+      DELETE1(_exception_use  ,_nb_inst);
+      DELETE1(_exception      ,_nb_inst);
     }
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 112)
@@ -57,5 +57,5 @@
     // ~~~~~[ Interface : "decod_in" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("decod_in",IN ,WEST,"Input of decod_queue", _param->_nb_inst_decod);
+      ALLOC1_INTERFACE_BEGIN("decod_in",IN ,WEST,_("Input of decod_queue"), _param->_nb_inst_decod);
 
       ALLOC1_VALACK_IN ( in_DECOD_IN_VAL            ,VAL);
@@ -85,9 +85,11 @@
       ALLOC1_SIGNAL_IN ( in_DECOD_IN_EXCEPTION_USE  ,"exception_use",Texception_t       ,_param->_size_exception_use         );
       ALLOC1_SIGNAL_IN ( in_DECOD_IN_EXCEPTION      ,"exception"    ,Texception_t       ,_param->_size_exception_decod       );
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_decod);
     }
 
     // ~~~~~[ Interface : "decod_out" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      ALLOC1_INTERFACE("decod_out",OUT,EAST,"Output of decod_queue", _param->_nb_inst_decod);
+      ALLOC1_INTERFACE_BEGIN("decod_out",OUT,EAST,_("Output of decod_queue"), _param->_nb_inst_decod);
 
       ALLOC1_VALACK_OUT(out_DECOD_OUT_VAL            ,VAL);
@@ -117,20 +119,26 @@
       ALLOC1_SIGNAL_OUT(out_DECOD_OUT_EXCEPTION_USE  ,"exception_use",Texception_t       ,_param->_size_exception_use         );
       ALLOC1_SIGNAL_OUT(out_DECOD_OUT_EXCEPTION      ,"exception"    ,Texception_t       ,_param->_size_exception_decod       );
+
+      ALLOC1_INTERFACE_END(_param->_nb_inst_decod);
     }
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~            
     {
-      ALLOC1_INTERFACE("depth",IN ,NORTH,"Depth", _param->_nb_context);
+      ALLOC1_INTERFACE_BEGIN("depth",IN ,NORTH,_("Depth"), _param->_nb_context);
 
       ALLOC1_SIGNAL_IN ( in_DEPTH_MIN      ,"min"      ,Tdepth_t           ,_param->_size_depth);
       ALLOC1_SIGNAL_IN ( in_DEPTH_MAX      ,"max"      ,Tdepth_t           ,_param->_size_depth);
       ALLOC1_SIGNAL_IN ( in_DEPTH_FULL     ,"full"     ,Tcontrol_t         ,1);
+
+      ALLOC1_INTERFACE_END(_param->_nb_context);
     }
 
     // ~~~~~[ Interface : "nb_inst" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~            
     {
-      ALLOC1_INTERFACE("nb_inst",OUT,NORTH,"Instruction's number", _param->_nb_context);
+      ALLOC1_INTERFACE_BEGIN("nb_inst",OUT,NORTH,_("Instruction's number"), _param->_nb_context);
 
       ALLOC1_SIGNAL_OUT(out_NB_INST_ALL    ,"all"      ,Tcontext_t         ,_param->_size_nb_inst_decod);
+
+      ALLOC1_INTERFACE_END(_param->_nb_context);
     }
 
@@ -140,13 +148,14 @@
     switch (_param->_queue_scheme)
       {
-      case DECOD_QUEUE_SCHEME_ONE_FIFO   : reg_QUEUE = new std::list<decod_queue_entry_t*>; break;
+      case DECOD_QUEUE_SCHEME_ONE_FIFO   : ALLOC0(reg_QUEUE,std::list<decod_queue_entry_t*>); break;
       case DECOD_QUEUE_SCHEME_MULTI_FIFO : ALLOC1(reg_QUEUE,std::list<decod_queue_entry_t*>,_param->_nb_bank); break;
       }
-    reg_NB_INST            = new uint32_t   [_param->_nb_context];
+
+    ALLOC1(reg_NB_INST,uint32_t,_param->_nb_context);
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-    internal_DECOD_IN_ACK  = new Tcontrol_t [_param->_nb_inst_decod];
-    internal_DECOD_OUT_VAL = new Tcontrol_t [_param->_nb_inst_decod];
-    internal_DECOD_OUT_ACK = new Tcontrol_t [_param->_nb_inst_decod];
+    ALLOC1(internal_DECOD_IN_ACK ,Tcontrol_t,_param->_nb_inst_decod);
+    ALLOC1(internal_DECOD_OUT_VAL,Tcontrol_t,_param->_nb_inst_decod);
+    ALLOC1(internal_DECOD_OUT_ACK,Tcontrol_t,_param->_nb_inst_decod);
       }
     
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 111)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_deallocation.cpp	(revision 112)
@@ -92,13 +92,34 @@
         switch (_param->_queue_scheme)
           {
-          case DECOD_QUEUE_SCHEME_ONE_FIFO   : delete reg_QUEUE; break;
-          case DECOD_QUEUE_SCHEME_MULTI_FIFO : DELETE1(reg_QUEUE,_param->_nb_bank); break;
-          } 
-        delete [] reg_NB_INST;
+          case DECOD_QUEUE_SCHEME_ONE_FIFO   :
+            {
+              while (not reg_QUEUE->empty())
+                {
+                  delete reg_QUEUE->front();
+                  reg_QUEUE->pop_front();
+                }
+
+              DELETE0(reg_QUEUE);
+              break;
+            }
+          case DECOD_QUEUE_SCHEME_MULTI_FIFO :
+            {
+              for (uint32_t i=0; i<_param->_nb_bank; ++i)
+                while (not reg_QUEUE[i].empty())
+                  {
+                    delete reg_QUEUE[i].front();
+                    reg_QUEUE[i].pop_front();
+                  }
+
+              DELETE1(reg_QUEUE,_param->_nb_bank); break;
+            } 
+          }
+
+        DELETE1(reg_NB_INST ,_param->_nb_context);
         
         // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-        delete [] internal_DECOD_IN_ACK ;
-        delete [] internal_DECOD_OUT_VAL;
-        delete [] internal_DECOD_OUT_ACK;
+        DELETE1(internal_DECOD_IN_ACK ,_param->_nb_inst_decod);
+        DELETE1(internal_DECOD_OUT_VAL,_param->_nb_inst_decod);
+        DELETE1(internal_DECOD_OUT_ACK,_param->_nb_inst_decod);
       }
 
